/*-
 * #%L
 * Smile CDR - CDR
 * %%
 * Copyright (C) 2016 - 2025 Smile CDR, Inc.
 * %%
 * All rights reserved.
 * #L%
 */
package com.example.server.r4.programmatic;

import ca.uhn.fhir.rest.annotation.Search;
import ca.uhn.fhir.rest.api.server.IBundleProvider;
import ca.uhn.fhir.rest.server.IResourceProvider;
import org.hl7.fhir.r4.model.Patient;

import java.util.Deque;
import java.util.LinkedList;

public class FakePatientResourceProvider implements IResourceProvider {

	public FakePatientResourceProvider() {}

	Deque<IBundleProvider> myBundleProviders = new LinkedList<>();

	public void addBundleProvider(IBundleProvider theBundleProvider) {
		myBundleProviders.offer(theBundleProvider);
	}

	@Search
	public IBundleProvider search() {
		return myBundleProviders.remove();
	}

	public Class<Patient> getResourceType() {
		return Patient.class;
	}
}
